#!/usr/bin/env bash

# Install apache2 first: sudo apt install apache2
rm -r ~/web
sudo rm -r /var/www/html/web 

mkdir ~/web

cat <<EOM > ~/web/init.py
from flask import Flask, render_template

app = Flask(__name__)

@app.route("/")
def home():
    return render_template("index.html")

if __name__ == "__main__":
    app.run(debug=True)
EOM

mkdir ~/web/templates

cat <<EOM > web/templates/index.html
<html>
  <head>
  </head>
  <body>

<center> <h1>Hello World, Flask</h1> </center>

  </body>
</html>
EOM

cat <<EOM > ~/web/app.wsgi
import sys

sys.path.insert(0, "/var/www/html/web")

from init import app as application
EOM

sudo mv ~/web /var/www/html/

sudo chown -R www-data: /var/www/html/web

sudo mv /etc/apache2/sites-available/000-default.conf /etc/apache2/sites-available/000-default.conf.orig

cat <<EOM | sudo tee /etc/apache2/sites-available/000-default.conf
<VirtualHost *:80>
        ServerAdmin webmaster@localhost

        WSGIScriptAlias / /var/www/html/web/app.wsgi
        <Directory /var/www/html/web>
            Order allow,deny
            Allow from all
        </Directory>

        ErrorLog ${APACHE_LOG_DIR}/error.log
        CustomLog ${APACHE_LOG_DIR}/access.log combined

</VirtualHost>
EOM

sudo apt install libapache2-mod-wsgi-py3

sudo a2enmod wsgi

sudo systemctl restart apache2
